
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>001在系统菜单中添加菜单项 / 憋错料</title>

    <meta name="description" content="001在系统菜单中添加菜单项 技术要点: 为了操作系统菜单,先要获取系统菜单指针,可以通过GetSystemMenu函数实现,然后利用菜单指针添加一个菜单项,最后在对话框OnSysCommand方法中处理菜单项的命令. GetSystemMenu方法用于获取一个系统菜单的指针,语法如下: CMenu* GetSystemMenu(BOOL bRect); bRect:FALSE时,该方法返回当前正在使用的系统菜单:TRUE时,该方法将重新设置系统菜单到默认状态,并且方法返回值不可用. 实现过程: (1)新建一个基于对话框的应">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">001在系统菜单中添加菜单项</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>技术要点：</p>
<p>为了操作系统菜单，先要获取系统菜单指针，可以通过GetSystemMenu函数实现，然后利用菜单指针添加一个菜单项，最后在对话框OnSysCommand方法中处理菜单项的命令。</p>
<p>GetSystemMenu方法用于获取一个系统菜单的指针，语法如下：</p>
<p>CMenu* GetSystemMenu(BOOL bRect);</p>
<p>bRect:FALSE时，该方法返回当前正在使用的系统菜单；TRUE时，该方法将重新设置系统菜单到默认状态，并且方法返回值不可用。</p>
<p>实现过程：</p>
<p>（1）新建一个基于对话框的应用程序</p>
<p>（2）在对话框类中定义一个菜单指针m_pMenu,用于指向系统菜单、</p>
<p>（3）主要程序代码。</p>
<p>在对话框初始化时，获取系统菜单指针，向系统菜单中添加菜单项，代码如下：</p>
<p>m_pMenu=GetSystemMenu(FALSE);</p>
<p>m_pMenu-&gt;AppendMenu(MF_STRING,IDI_PECULIARMENU,"系统菜单");</p>
<p>在对话框的OnSysCommand方法中添加消息处理代码：</p>
<p>else if(nID==IDI_PECULIARMENU)</p>
<p>{</p>
<p>　　MessageBox("系统菜单","提示",MB_OK|MB_ICONINFORMATION);</p>
<p>}</p>
<p>执行结果：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9pLzYzODczMy8yMDE0MDcvMTAxMzUwMjk3NTQ0NDY2LmpwZw==.jpg" /></p>
<p>注意：这里图标和背景都有所改变，因为还进行其他操作：</p>
<p>1、在构造函数中，装载了左上角的新图标。</p>
<p>m_hIcon = AfxGetApp()-&gt;LoadIcon(IDI_MAINMENU);</p>
<p>2、在OnPaint()函数中，增加了添加背景的代码，如下：</p>
<p>CDC* m_dc = this-&gt;GetDC();<br />&nbsp;CDC m_memdc;<br />&nbsp;m_memdc.CreateCompatibleDC(m_dc);<br />&nbsp;CBitmap m_bitmap;<br />&nbsp;m_bitmap.LoadBitmap(IDB_MAIN);<br />&nbsp;m_memdc.SelectObject(&amp;m_bitmap);<br />&nbsp;m_dc-&gt;BitBlt(0,0,800,700,&amp;m_memdc,0,0,SRCCOPY);<br />&nbsp;m_bitmap.DeleteObject();</p>
<p><P>001在系统菜单中添加菜单项</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 08:37:12 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/for/" title="for">for</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/2014/" title="2014">2014</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>001在系统菜单中添加菜单项的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vQOvX0.html" rel="bookmark">Delphi 在系统菜单中添加菜单项</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 unit Unit001; 2 3 interface 4 5 uses 6 Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics, 7 Vcl.Controls, Vcl.Forms, Vcl.Dialogs; 8 9 type 10 TForm1 = class(TForm) 11 procedure FormCreate(Sender:TObject			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBAAyy4.html" rel="bookmark">Delphi在系统菜单中添加菜单项</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				unit dy219; interface uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs; type TForm1 = class(TForm) procedure FormCreate(Sender: TObject); private procedure sysmenu(var msg: twmmenuselect);message wm_syscommand;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Kdg8K3.html" rel="bookmark">mfc 小程序---在系统菜单中添加菜单项</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1建立一个对话框工程:在dlg类里定义一个菜单指针m_pMenu,在对话框OnInitDialog函数里添加代码: m_pMenu=GetSystemMenu(FALSE);//获取系统菜单的指针 m_pMenu-&gt;AppendMenu(MF_SEPARATOR);//添加分割线 m_pMenu-&gt;AppendMenu(MF_STRING,IDI_PECULIARMENU,&quot;系统菜单&quot;); 补充:IDI_PECULIARMENU 为一个常数,需要在Resourece.h中宏			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDjlgK3.html" rel="bookmark">centos 7 在应用菜单中添加菜单项</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				gnome桌面的所有菜单项都存储如下位置: /usr/share/applications/ 新建一个菜单项,直接在该目录下新建一个后缀名为.desktop的文件即可. $ vi /usr/share/applications/newitem.desktop 文件内容如下: [Desktop Entry]Version=1.0Name=My ProgramIcon=/some/pathExec=/home/danny/some/path/myprog/progTerminal=falseType			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YZJBJ3.html" rel="bookmark">Delphi通过AppendMenu和DeleteMenu在系统菜单中添加删除菜单项</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Delphi在系统菜单中添加删除系统菜单项 Delphi在系统菜单中添加删除系统菜单项,利用Windows提供的API函数GetSystemMenu可以得到窗口的系统菜单句柄,再通过AppendMenu和DeleteMenu就可以添加和删除菜单了. 工具/原料 Delphi7 Windows电脑 方法/步骤 打开Delphi7,创建新的工程,默认新窗体的Name属性为Form1   在Form1的Object Inspector中Events里双击OnCreate为Form1创建OnCreate			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RWQBy3.html" rel="bookmark">CentOS7 系统菜单中添加快捷方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一,在桌面新建一个文件 文件名随意,但必须带有.desktop的后缀名, 以Eclipse为例 vi /usr/share/applications/eclipse.desktop 二,在文件中写入如下内容 [Desktop Entry] Encoding=UTF-8 Name=Eclipse Comment=Eclipse IDE for C/C++ Exec=/home/workspace/eclipse/eclipse Icon=/home/workspace/eclipse/icon.x			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MErJbK0.html" rel="bookmark">如何在win10系统的开始菜单中添加&OpenCurlyDoubleQuote;设备和打印机&rdquo;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一些细心的用户会发现,win10和win7的&quot;设备和打印机&quot;的位置不一样.Win7的系统,在开始菜单中一般都会有&quot;设备和打印机&quot;这个选项,找到后直接打开就可以了,但是win10的这些快捷操作按钮却不见了.但是大家不要着急,小编这就教大家如何添加win10系统的&quot;设备和打印机&quot;. 1.打开&quot;控制面板&quot;,找到&quot;硬件和声音&quot;,点击进去,然后再找到&quot;设备和打印机&quot;: 2.在&quot;设备和打印			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49ZewnM.html" rel="bookmark">&lbrack;Firefox附加组件&rsqb;0002&period;添加菜单项</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Add-onSDK 还不能为火狐浏览器提供一个API添加新的菜单项.但它是可扩展的设计,所以任何人都可以建立和发布模块,使用插件开发者.大牛埃里克沃尔德写的MenuItems模块,能够使我们很方便的添加菜单项. 开发步骤 1.老规矩首先创建一个新的扩展程序.创建一个目录名称为&quot;ItemTest&quot;(自己随便取),并运行cfx init初始化 . mkdir ItemTest cd ItemTest cfx init 2.安装 menuitems [1].从https://github.c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLjAAE3.html" rel="bookmark">Cocos2d-X中创建菜单项</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Cocos2d-X中创建菜单的类: CCMenuItemFont:创建纯文本的菜单项 CCMenuItemAtlasFont:创建带有艺术字体的菜单项 CCMenuItemImage:用图片创建菜单项 CCMenuItemLabel:用标签创建菜单项 CCMenuItemSprite:用精灵创建菜单项 CCMenuItemToggle:创建可以来回切换的菜单项如ON/OFF 程序实例:创建一个纯文本菜单项 程序代码: #include &quot;MenuItem.h&quot; CCScene* Men			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V0bnxw0.html" rel="bookmark" class="title">汽车检测SIFT&plus;BOW&plus;SVM</a>
					<div>
						整个执行过程如下:1)获取一个训练数据集. 2)创建BOW训练器并获得视觉词汇. 3)采用词汇训练SVM. 4)尝试对测试图像的图像金字塔采用滑动宽口进行检测. 5)对重叠的矩形使用非极大抑制. 6) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lX9EZ0.html" rel="bookmark" class="title">数据遍历性能安全考虑</a>
					<div>
						循环语句是程序最基本的语法,但往往容易出现让你意想不到的死循环,为之在each函数上做限制,避免死循环. 控制台中运行查看结果: function each(arr, fn){ var maxTime ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGGqN6M.html" rel="bookmark" class="title">Android 高级UI设计笔记06：仿微信图片选择器</a>
					<div>
						仿微信图片选择器: 一.项目整体分析: 1. Android加载图片的3个目标: (1)尽可能的去避免内存溢出. a. 根据图片的显示大小去压缩图片 b. 使用缓存对我们图片进行管理(LruCache ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wR9gZ0.html" rel="bookmark" class="title">css框架</a>
					<div>
						CSS框架 960Grid 即960布局,现基本不再使用 Bootstrap 需将页面设置为HTML5文档类型 1. 引入外部CSS文件 使用&lt;link&gt;引入,一般只引入核心文件,主题文件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qvQbW4.html" rel="bookmark" class="title">form表单回车提交问题</a>
					<div>
						最近发现在form里的一个input敲击回车键时会提交form表单.查了资料,发现会出现这个情况的原因是浏览器帮我们做了处理.这里总结几条规则: 1. 如果表单里有一个type=&quot;submi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPDoOyM.html" rel="bookmark" class="title">丢失的勤奋，我需要静静</a>
					<div>
						最近的状态只能用两个字形容:糟糕!稍微复杂点的代码就不想写,要自己设计思路的也不想写,高数不想写,数字逻辑不想写.我把自己沉浸于网络小说中,总是想着&quot;看完这本书我就赶紧学习!&quot;,然 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXLym8M.html" rel="bookmark" class="title">Error&colon;dijit&period;tree&period;TreeStoreModel&colon;root query returned 0 items</a>
					<div>
						1.错误描写叙述 error loading root:                                            Tree.js(第341行) Error:dijit.t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RDP974.html" rel="bookmark" class="title">SAP 已经有17个模块</a>
					<div>
						传统五大郎: MM,SD,PP,FI 财务会计CO 管理会计 +QM 质量管理 (制造业用的不少)+ABAP.BASIS.BW BI商务智能的组件之一CRM 客户管理SRM 供应商管理(物资管理集约化 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xrJAD4.html" rel="bookmark" class="title">css3属性：美化表单、点击元素产生的背景与边框怎么去掉，滚动回弹效果</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rkRbg4.html" rel="bookmark" class="title">2016年9月3日 星期六 --出埃及记 Exodus 16&colon;35</a>
					<div>
						The Israelites ate manna forty years, until they came to a land that was settled; they ate manna unt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWG2y4.html" rel="bookmark" class="title">直播造轮子－分页</a>
					<div>
						虽说分页已经被人们撸过无数个了,但是目测还没有一个有我撸的好的&gt;-&lt; 不信我撸给你看. 一.应用场景 我需要这样一个分页组件,它有首页.上一页.上一组.一组页码.下一组.下一页.末页,可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xvDPj4.html" rel="bookmark" class="title">编程一堆煎饼中间排序1</a>
					<div>
						得到这个问题. 第一反应是使用算法思想分治, 每次当前最大薄烤饼的到指定地点 .这样的思想很简单,实现也很easy.可是这仅仅是提供了,问题的一个可行解,看完书中的内容之后发现.题目中要求的是最优化的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyWykA3.html" rel="bookmark" class="title">Codeforces Round &num;283 &lpar;Div&period; 2&rpar;   题解</a>
					<div>
						A. Minimum Difficulty Mike is trying rock climbing but he is awful at it. There are n holds on the w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWVeeL4.html" rel="bookmark" class="title">女性想要什么&quest;</a>
					<div>
						在2016年的中国,大多数女性将成功定义为健康.家庭和幸福,尤其是期望事业和家庭双成功,这也是多数女性在职场中遇到的最大的挑战——事业与家庭的平衡.不过,年龄.婚姻和生育改变了女性追求事业的方式——女 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MymYpeM.html" rel="bookmark" class="title">小米盒子救砖之路</a>
					<div>
						我的小米盒子1S标准版(MDZ-06-AA),因为刷了石头的ROM,一开始还好用 没过几天各种卡顿,实在受不了,就用了一下石头的系统还原功能了,好了,悲剧发生了! 还原过的版本的根本进不了系统,就是那 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzL69O3.html" rel="bookmark" class="title">css弹性盒布局</a>
					<div>
						参考:https://segmentfault.com/a/1190000003978624 ul{ display: -webkit-box; display: -webkit-flex; disp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OZVjP0.html" rel="bookmark" class="title">SET ANSI&lowbar;WARNINGS &lbrace; ON &vert; OFF &rcub;</a>
					<div>
						SET ANSI_WARNINGS { ON | OFF } 注释 SET ANSI_WARNINGS 影响以下情况: 当设置为 ON 时,如果聚合函数(如 SUM.AVG.MAX.MIN.STDEV ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QaLJ24.html" rel="bookmark" class="title">x信号量</a>
					<div>
						comm.h   1 #include&lt;stdio.h&gt;   2 #include&lt;stdlib.h&gt;   3 #include&lt;sys/types.h&gt;   4  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02wnmB3.html" rel="bookmark" class="title">ARM装配说明MCR&sol;MRC学习</a>
					<div>
						MCR指令ARM数据寄存器传送到协处理器寄存器.假设协处理器不能成功运行操作.会产生未定义指令中止. 语法教学格式: MCR{&lt;cond&gt;} p15, 0, &lt;Rd&gt;, &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBWLVA0.html" rel="bookmark" class="title">阿里巴巴安全部道哥、云舒3月10日在北邮讲座小记</a>
					<div>
						PS:作为一个计算机行业安全研究人员,感觉到做学术不可与业界完全脱离,固特去北邮旁听,有些ideas很让人受启发! 附链接:http://bbs.byr.cn/#!article/Security/3 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
